Index: palm/trunk/SOURCE/advec_v_ups.f90
===================================================================
--- palm/trunk/SOURCE/advec_v_ups.f90	(revision 1)
+++ palm/trunk/SOURCE/advec_v_ups.f90	(revision 1)
@@ -0,0 +1,194 @@
+ SUBROUTINE advec_v_ups
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: advec_v_ups.f90,v $
+! Revision 1.7  2004/04/30 08:03:52  raasch
+! Enlarged transposition arrays introduced
+!
+! Revision 1.6  2003/03/16 09:25:59  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.5  2001/03/29 17:36:43  raasch
+! v_ad is now allocated locally, several temporary arrays removed from
+! argument lists of spline_* and long_filter_*
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.4  2001/01/22 08:31:10  raasch
+! Module test_variables removed
+!
+!
+! Revision 1.2  2000/01/20 09:52:54  letzel
+! All comments translated into English
+!
+! Revision 1.1  1999/02/05 08:50:32  raasch
+! Initial revision
+!
+!
+! Description:
+! ------------
+! Upstream-Spline advection of the v velocity-component. The advection process
+! is divided into three subsequent steps, one for each of the dimensions. The
+! result is stored as a tendency in array tend. The computation of the cubic
+! splines and the possible execution of the Long-filter require that all grid
+! points of the relevant dimension are available. For model runs on more than
+! one PE therefore both the advected and the advecting quantities are
+! transposed accordingly.
+!
+! Internally used arrays:
+! v_ad = scalar quantity to be advected, initialised = v at the beginning,
+!        also being used as temporary storage after each time step
+! d    = advecting component (u, v, or w)
+!------------------------------------------------------------------------------!
+
+    USE advection
+    USE arrays_3d
+    USE cpulog
+    USE grid_variables
+    USE indices
+    USE interfaces
+    USE control_parameters
+
+    IMPLICIT NONE
+
+    INTEGER ::  i, j, k
+    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  v_ad
+
+
+    CALL cpu_log( log_point_s(18), 'advec_v_ups', 'start' )
+
+#if defined( __parallel )
+
+!
+!-- Advection of v in x-direction:
+!-- Store v in temporary array v_ad (component to be advected, boundaries
+!-- are not used because they disturb the transposition)
+    ALLOCATE( v_ad(nzb+1:nzta,nys:nyna,nxl:nxra) )
+    v_ad = 0.0
+    v_ad(nzb+1:nzt,nys:nyn,nxl:nxr) = v(nzb+1:nzt,nys:nyn,nxl:nxr)
+
+!
+!-- Enlarge the size of tend, used as a working array for the transpositions
+    IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
+       DEALLOCATE( tend )
+       ALLOCATE( tend(1:nza,nys:nyna,nxl:nxra) )
+    ENDIF
+
+!
+!-- Transpose the component to be advected: z --> x
+    CALL transpose_zx( v_ad, tend, v_ad, tend, v_ad )
+
+#else
+
+!
+!-- Advection of v in x-direction:
+!-- Store v in temporary array v_ad (component to be advected)
+    ALLOCATE( v_ad(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+    v_ad(:,:,:) = v(:,:,:)
+
+#endif
+
+!
+!-- Advecting component (u) must be averaged out on the v grid
+    d = 0.0
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+             d(k,j,i) = 0.25 * ( u(k,j-1,i) + u(k,j-1,i+1) + &
+                                 u(k,j,i+1) + u(k,j,i) ) - u_gtrans
+          ENDDO
+       ENDDO
+    ENDDO
+
+#if defined( __parallel )
+
+!
+!-- Transpose the advecting component: z --> x
+    CALL transpose_zx( d, tend, d, tend, d )
+
+#endif
+
+!
+!-- Upstream-Spline advection of v in x-direction. Array tend comes out
+!-- as v_ad before the advection step including cyclic boundaries.
+!-- It is needed for the long filter.
+    CALL spline_x( v_ad, d, 'v' )
+
+!
+!-- Advection of v in y-direction:
+!-- advecting component (d) = component to be advected (v)
+    d(nzb+1:nzt,nys:nyn,nxl:nxr) = v(nzb+1:nzt,nys:nyn,nxl:nxr) - v_gtrans
+
+#if defined( __parallel )
+
+!
+!-- Transpose the advecting component: z --> y
+    CALL transpose_zx( d, tend, d, tend, d )
+    CALL transpose_xy( d, tend, d, tend, d )
+
+!
+!-- Transpose the component to be advected: x --> y
+    CALL transpose_xy( v_ad, tend, v_ad, tend, v_ad )
+
+#endif
+
+!
+!-- Upstream-Spline advection of v in y-direction
+    CALL spline_y( v_ad, d, 'v' )
+
+!
+!-- Advection of v in z-direction:
+!-- the advecting component (w) must be averaged out on the v grid
+!-- (weighted for non-equidistant grid)
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+             d(k,j,i) =  ( 0.5 * ( w(k-1,j-1,i) + w(k-1,j,i) ) * &
+                                 ( zw(k) - zu(k) ) + &
+                           0.5 * ( w(k,j,i) + w(k,j-1,i) ) * &
+                                 ( zu(k) - zw(k-1) ) &
+                         ) * ddzw(k)
+          ENDDO
+       ENDDO
+    ENDDO
+
+#if defined( __parallel )
+    
+!
+!-- Transpose the component to be advected: y --> z (= y --> x + x --> z)
+    CALL transpose_yx( v_ad, tend, v_ad, tend, v_ad )
+    CALL transpose_xz( v_ad, tend, v_ad, tend, v_ad )
+
+!
+!-- Resize tend to its normal size
+    IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
+       DEALLOCATE( tend )
+       ALLOCATE( tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+    ENDIF
+
+#endif
+
+!
+!-- Upstream-Spline advection of v in z-direction
+    CALL spline_z( v_ad, d, dzu, spl_tri_zu, 'v' )
+
+!
+!-- Compute the tendency term
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+             tend(k,j,i) = ( v_ad(k,j,i) - v(k,j,i) ) / dt_3d 
+          ENDDO
+       ENDDO
+    ENDDO
+
+    DEALLOCATE( v_ad )
+
+    CALL cpu_log( log_point_s(18), 'advec_v_ups', 'stop' )
+
+ END SUBROUTINE advec_v_ups
Index: palm/trunk/SOURCE/advec_w_pw.f90
===================================================================
--- palm/trunk/SOURCE/advec_w_pw.f90	(revision 4901)
+++ palm/trunk/SOURCE/advec_w_pw.f90	(revision 1)
@@ -1,34 +1,39 @@
-!> @file advec_w_pw.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ MODULE advec_w_pw_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
+! $Log: advec_w_pw.f90,v $
+! Revision 1.15  2006/02/23 09:47:01  raasch
+! nzb_2d replaced by nzb_w_inner
 !
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
-! 
-! 3655 2019-01-07 16:51:22Z knoop
-! variables documented
+! Revision 1.14  2004/01/30 10:13:07  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.13  2003/03/12 16:19:29  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
+!
+! Revision 1.12  2002/06/11 12:27:33  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+!
+! Revision 1.11  2001/03/29 17:37:10  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.10  2001/01/22 05:19:42  raasch
+! Module test_variables removed
+!
+! Revision 1.9  2000/01/20 10:18:31  letzel
+! All comments translated into English
+!
+! Revision 1.8  1998/08/05 06:51:10  raasch
+! Alle Gitterpunkte werden gleich behandelt (keine zentralen Differenzenquotien-
+! ten mehr bei Vertikaladvektion bei k=1)
 !
 ! Revision 1.1  1997/08/11 06:10:29  raasch
@@ -38,11 +43,9 @@
 ! Description:
 ! ------------
-!> Advection term for w velocity-component using Piacsek and Williams.
-!> Vertical advection at the first grid point above the surface is done with normal centred
-!> differences, because otherwise no information from the surface would be communicated upwards due
-!> to w=0 at k=nzb.
-!--------------------------------------------------------------------------------------------------!
- MODULE advec_w_pw_mod
- 
+! Advection term for w velocity-component using Piacsek and Williams.
+! Vertical advection at the first grid point above the surface is done with
+! normal centred differences, because otherwise no information from the surface
+! would be communicated upwards due to w=0 at k=nzb.
+!------------------------------------------------------------------------------!
 
     PRIVATE
@@ -57,100 +60,72 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for all grid points
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_w_pw
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_w_pw
 
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzu, tend, u, v, w
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
+       IMPLICIT NONE
 
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
+       INTEGER ::  i, j, k
+       REAL    ::  gu, gv
 
-    USE indices,                                                                                   &
-        ONLY:  nxl, nxr, nyn, nys, nzb, nzt
+ 
+       gu = 2.0 * u_gtrans
+       gv = 2.0 * v_gtrans
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_w_inner(j,i)+1, nzt
+                tend(k,j,i) = tend(k,j,i) - 0.25 * (                           &
+                         ( w(k,j,i+1) * ( u(k+1,j,i+1) + u(k,j,i+1) - gu )     &
+                         - w(k,j,i-1) * ( u(k+1,j,i) + u(k,j,i) - gu ) ) * ddx &
+                       + ( w(k,j+1,i) * ( v(k+1,j+1,i) + v(k,j+1,i) - gv )     &
+                         - w(k,j-1,i) * ( v(k+1,j,i) + v(k,j,i) - gv ) ) * ddy &
+                       + ( w(k+1,j,i) * ( w(k+1,j,i) + w(k,j,i) )              &
+                         - w(k-1,j,i) * ( w(k,j,i) + w(k-1,j,i) ) )            &
+                                                                  * ddzu(k+1)  &
+                                                   )
+             ENDDO
+          ENDDO
+       ENDDO
 
-    USE kinds
+    END SUBROUTINE advec_w_pw
 
 
-    IMPLICIT NONE
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_w_pw_ij( i, j )
 
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
-    
-    REAL(wp)     ::  gu !< Galilei-transformation velocity along x
-    REAL(wp)     ::  gv !< Galilei-transformation velocity along y
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    ::  gu, gv
 
 
-    gu = 2.0_wp * u_gtrans
-    gv = 2.0_wp * v_gtrans
-    DO  i = nxl, nxr
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt
-             tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                                               &
-                           ( w(k,j,i+1)   * ( u(k+1,j,i+1) + u(k,j,i+1) - gu )                     &
-                           - w(k,j,i-1)   * ( u(k+1,j,i)   + u(k,j,i) - gu ) ) * ddx               &
-                           + ( w(k,j+1,i) * ( v(k+1,j+1,i) + v(k,j+1,i) - gv )                     &
-                           - w(k,j-1,i)   * ( v(k+1,j,i)   + v(k,j,i) - gv ) ) * ddy               &
-                           + ( w(k+1,j,i) * ( w(k+1,j,i)   + w(k,j,i) )                            &
-                           - w(k-1,j,i)   * ( w(k,j,i)     + w(k-1,j,i) ) )    * ddzu(k+1)         &
-                                                   )
-          ENDDO
+       gu = 2.0 * u_gtrans
+       gv = 2.0 * v_gtrans
+       DO  k = nzb_w_inner(j,i)+1, nzt
+          tend(k,j,i) = tend(k,j,i) - 0.25 * (                              &
+                         ( w(k,j,i+1) * ( u(k+1,j,i+1) + u(k,j,i+1) - gu )     &
+                         - w(k,j,i-1) * ( u(k+1,j,i) + u(k,j,i) - gu ) ) * ddx &
+                       + ( w(k,j+1,i) * ( v(k+1,j+1,i) + v(k,j+1,i) - gv )     &
+                         - w(k,j-1,i) * ( v(k+1,j,i) + v(k,j,i) - gv ) ) * ddy &
+                       + ( w(k+1,j,i) * ( w(k+1,j,i) + w(k,j,i) )              &
+                         - w(k-1,j,i) * ( w(k,j,i) + w(k-1,j,i) ) )            &
+                                                                  * ddzu(k+1)  &
+                                                )
        ENDDO
-    ENDDO
 
- END SUBROUTINE advec_w_pw
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for grid point i,j
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_w_pw_ij( i, j )
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzu, tend, u, v, w
-
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
-
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
-
-    USE indices,                                                                                   &
-        ONLY:  nzb, nzt
-
-    USE kinds
-
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
-    
-    REAL(wp)     ::  gu !< Galilei-transformation velocity along x
-    REAL(wp)     ::  gv !< Galilei-transformation velocity along y
-
-    gu = 2.0_wp * u_gtrans
-    gv = 2.0_wp * v_gtrans
-    DO  k = nzb+1, nzt
-       tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                                                     &
-                      ( w(k,j,i+1)   * ( u(k+1,j,i+1) + u(k,j,i+1) - gu )                          &
-                      - w(k,j,i-1)   * ( u(k+1,j,i)   + u(k,j,i) - gu ) ) * ddx                    &
-                      + ( w(k,j+1,i) * ( v(k+1,j+1,i) + v(k,j+1,i) - gv )                          &
-                      - w(k,j-1,i)   * ( v(k+1,j,i)   + v(k,j,i) - gv ) ) * ddy                    &
-                      + ( w(k+1,j,i) * ( w(k+1,j,i)   + w(k,j,i) )                                 &
-                      - w(k-1,j,i)   * ( w(k,j,i)     + w(k-1,j,i) ) )    * ddzu(k+1)              &
-                                             )
-    ENDDO
- END SUBROUTINE advec_w_pw_ij
+    END SUBROUTINE advec_w_pw_ij
 
  END MODULE advec_w_pw_mod
Index: palm/trunk/SOURCE/advec_w_up.f90
===================================================================
--- palm/trunk/SOURCE/advec_w_up.f90	(revision 4901)
+++ palm/trunk/SOURCE/advec_w_up.f90	(revision 1)
@@ -1,34 +1,44 @@
-!> @file advec_w_up.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ MODULE advec_w_up_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
-! 
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
-! 
-! 3655 2019-01-07 16:51:22Z knoop
-! variables documented
+! $Log: advec_w_up.f90,v $
+! Revision 1.11  2006/02/23 09:47:23  raasch
+! *** empty log message ***
+!
+! Revision 1.10  2004/01/30 10:13:31  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.9  2003/03/12 16:20:07  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
+!
+! Revision 1.8  2002/06/11 12:28:33  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+!
+! Revision 1.7  2001/03/29 17:37:31  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.6  2001/01/22 05:21:01  raasch
+! Module test_variables removed
+!
+! Revision 1.5  2000/01/20 10:22:08  letzel
+! All comments translated into English
+!
+! Revision 1.4  1998/07/06 12:06:25  raasch
+! + USE test_variables
+!
+! Revision 1.3  1998/04/21 15:54:20  raasch
+! Galilei-Transformation eingebaut
+!
+! Revision 1.2  1997/09/09 08:28:55  raasch
+! Kehrwerte der Gitterweiten implementiert
 !
 ! Revision 1.1  1997/08/29 08:56:33  raasch
@@ -38,10 +48,8 @@
 ! Description:
 ! ------------
-!> Advection term for the w velocity-component using upstream scheme.
-!> NOTE: vertical advection at k=1 still has wrong grid spacing for w>0
-!>       The same problem occurs for all topography boundaries!
-!--------------------------------------------------------------------------------------------------!
- MODULE advec_w_up_mod
- 
+! Advection term for the w velocity-component using upstream scheme.
+! NOTE: vertical advection at k=1 still has wrong grid spacing for w>0
+!       The same problem occurs for all topography boundaries!
+!------------------------------------------------------------------------------!
 
     PRIVATE
@@ -56,130 +64,114 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for all grid points
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_w_up
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_w_up
 
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzw, tend, u, v, w
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
+       IMPLICIT NONE
 
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
-
-    USE indices,                                                                                   &
-        ONLY:  nxl, nxr, nyn, nys, nzb, nzt
-
-    USE kinds
+       INTEGER ::  i, j, k
+       REAL    ::  ukomp, vkomp
 
 
-    IMPLICIT NONE
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_w_inner(j,i)+1, nzt-1
+!
+!--             x-direction
+                ukomp = 0.25 * ( u(k,j,i)   + u(k,j,i+1) + &
+                                 u(k+1,j,i) + u(k+1,j,i+1) ) - u_gtrans
+                IF ( ukomp > 0.0 )  THEN
+                   tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( w(k,j,i) - w(k,j,i-1) ) * ddx
+                ELSE
+                   tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( w(k,j,i+1) - w(k,j,i) ) * ddx
+                ENDIF
+!
+!--             y-direction
+                vkomp = 0.25 * ( v(k,j,i) + v(k,j+1,i) + &
+                                 v(k+1,j,i) + v(k+1,j+1,i) ) - v_gtrans
+                IF ( vkomp > 0.0 )  THEN
+                   tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( w(k,j,i) - w(k,j-1,i) ) * ddy
+                ELSE
+                   tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( w(k,j+1,i) - w(k,j,i) ) * ddy
+                ENDIF
+!
+!--             z-direction
+                IF ( w(k,j,i) > 0.0 )  THEN
+                   tend(k,j,i) = tend(k,j,i) - w(k,j,i) * &
+                                         ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
+                ELSE
+                   tend(k,j,i) = tend(k,j,i) - w(k,j,i) * &
+                                         ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)
+                ENDIF
 
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
+             ENDDO
+          ENDDO
+       ENDDO
 
-    REAL(wp) ::  ukomp !< advection velocity along x-direction 
-    REAL(wp) ::  vkomp !< advection velocity along y-direction 
+    END SUBROUTINE advec_w_up
 
 
-    DO  i = nxl, nxr
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt-1
-!
-!--          x-direction
-             ukomp = 0.25_wp * ( u(k,j,i)   + u(k,j,i+1) + u(k+1,j,i) + u(k+1,j,i+1) ) - u_gtrans
-             IF ( ukomp > 0.0_wp )  THEN
-                tend(k,j,i) = tend(k,j,i) - ukomp * ( w(k,j,i) - w(k,j,i-1) ) * ddx
-             ELSE
-                tend(k,j,i) = tend(k,j,i) - ukomp * ( w(k,j,i+1) - w(k,j,i) ) * ddx
-             ENDIF
-!
-!--          y-direction
-             vkomp = 0.25_wp * ( v(k,j,i) + v(k,j+1,i) + v(k+1,j,i) + v(k+1,j+1,i) ) - v_gtrans
-             IF ( vkomp > 0.0_wp )  THEN
-                tend(k,j,i) = tend(k,j,i) - vkomp * ( w(k,j,i) - w(k,j-1,i) ) * ddy
-             ELSE
-                tend(k,j,i) = tend(k,j,i) - vkomp * ( w(k,j+1,i) - w(k,j,i) ) * ddy
-             ENDIF
-!
-!--          z-direction
-             IF ( w(k,j,i) > 0.0_wp )  THEN
-                tend(k,j,i) = tend(k,j,i) - w(k,j,i) * ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
-             ELSE
-                tend(k,j,i) = tend(k,j,i) - w(k,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)
-             ENDIF
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_w_up_ij( i, j )
 
-          ENDDO
-       ENDDO
-    ENDDO
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
- END SUBROUTINE advec_w_up
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    ::  ukomp, vkomp
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for grid point i,j
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_w_up_ij( i, j )
+       DO  k = nzb_w_inner(j,i)+1, nzt-1
+!
+!--       x-direction
+          ukomp = 0.25 * ( u(k,j,i) + u(k,j,i+1) + u(k+1,j,i) + u(k+1,j,i+1) &
+                         ) - u_gtrans
+          IF ( ukomp > 0.0 )  THEN
+             tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( w(k,j,i) - w(k,j,i-1) ) * ddx
+          ELSE
+             tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( w(k,j,i+1) - w(k,j,i) ) * ddx
+          ENDIF
+!
+!--       y-direction
+          vkomp = 0.25 * ( v(k,j,i) + v(k,j+1,i) + v(k+1,j,i) + v(k+1,j+1,i) &
+                         ) - v_gtrans
+          IF ( vkomp > 0.0 )  THEN
+             tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( w(k,j,i) - w(k,j-1,i) ) * ddy
+          ELSE
+             tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( w(k,j+1,i) - w(k,j,i) ) * ddy
+          ENDIF
+!
+!--       z-direction
+          IF ( w(k,j,i) > 0.0 )  THEN
+             tend(k,j,i) = tend(k,j,i) - w(k,j,i) * &
+                                         ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
+          ELSE
+             tend(k,j,i) = tend(k,j,i) - w(k,j,i) * &
+                                         ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)
+          ENDIF
 
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzw, tend, u, v, w
+       ENDDO
 
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
-
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
-
-    USE indices,                                                                                   &
-        ONLY:  nzb, nzt
-
-    USE kinds
-
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
-
-    REAL(wp) ::  ukomp !< advection velocity along x-direction 
-    REAL(wp) ::  vkomp !< advection velocity along y-direction 
-
-
-    DO  k = nzb+1, nzt-1
-!
-!--    x-direction
-       ukomp = 0.25_wp * ( u(k,j,i) + u(k,j,i+1) + u(k+1,j,i) + u(k+1,j,i+1) ) - u_gtrans
-       IF ( ukomp > 0.0_wp )  THEN
-          tend(k,j,i) = tend(k,j,i) - ukomp * ( w(k,j,i) - w(k,j,i-1) ) * ddx
-       ELSE
-          tend(k,j,i) = tend(k,j,i) - ukomp * ( w(k,j,i+1) - w(k,j,i) ) * ddx
-       ENDIF
-!
-!--    y-direction
-       vkomp = 0.25_wp * ( v(k,j,i) + v(k,j+1,i) + v(k+1,j,i) + v(k+1,j+1,i) ) - v_gtrans
-       IF ( vkomp > 0.0_wp )  THEN
-          tend(k,j,i) = tend(k,j,i) - vkomp * ( w(k,j,i) - w(k,j-1,i) ) * ddy
-       ELSE
-          tend(k,j,i) = tend(k,j,i) - vkomp * ( w(k,j+1,i) - w(k,j,i) ) * ddy
-       ENDIF
-!
-!--    z-direction
-       IF ( w(k,j,i) > 0.0_wp )  THEN
-          tend(k,j,i) = tend(k,j,i) - w(k,j,i) * ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
-       ELSE
-          tend(k,j,i) = tend(k,j,i) - w(k,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)
-       ENDIF
-
-    ENDDO
-
- END SUBROUTINE advec_w_up_ij
+    END SUBROUTINE advec_w_up_ij
 
  END MODULE advec_w_up_mod
